#ifndef _HAVE_SOUND_H
#define _HAVE_SOUND_H

#define SYNTH_SQUARE 1
#define SYNTH_NOISE 2

typedef struct
{
	float length, pos, delay, usedelay, freq, amp, freq_start, freq_end, amp_start, amp_end;
	int waveform, active, phase;
} Synth;

int sound_setup();
int sound_quit();
Synth* sound_synth_get(int n);
int sound_synth_play(Synth* synth);
int sound_set_song(int n);

#else
#endif
